﻿import socket
import threading
import re
import os

os.system('cls' if os.name == 'nt' else 'clear')
print("Client for DMconnect server.")
print("Copyright (c) 1998 PredoK_CyXaR & BitByByte")
print("")

client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
stop_event = threading.Event()
host = "147.185.221.19"
port = 42439

last_sent_message = None

def extract_message_content(full_message):
    match = re.match(r"^.*?:\s*(.*)$", full_message)
    if match:
        return match.group(1)
    return full_message

def receive_messages():
    global last_sent_message
    while not stop_event.isSet():
        try:
            message = client_socket.recv(1024).strip()
            if not message:
                break

            try:
                message = message.decode('utf-8')
            except Exception:
                pass

            message_content = extract_message_content(message)

            if message_content != last_sent_message:
                print(message)
            else:
                last_sent_message = None
        except Exception, e:
            if not stop_event.isSet():
                print("Error getting message: " + str(e))
            break

def start_receiving_thread():
    receive_thread = threading.Thread(target=receive_messages)
    receive_thread.setDaemon(True)
    receive_thread.start()

try:
    client_socket.connect((host, port))
    start_receiving_thread()
except Exception, e:
    print("Connection error: " + str(e))

while True:
    msg = raw_input()
    last_sent_message = msg

    client_socket.send(msg)
